package sound.soundDemo;

/*
 * Copyright 2002 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

import javax.swing.*;
import java.awt.*;

/**
 * A demo that shows JavaSound features.
 *
 * Parameters that can be used in the JavaSound.html file inside
 * the applet tag to customize demo runs :
 *            <param name="dir" value="audioDirectory">
 *
 * JavaSoundApplet.java	1.4	02/02/06
 * @author Brian Lichtenwalter
 */
public class JavaSoundApplet extends JApplet {

    private static JavaSoundApplet applet;
    private JavaSound demo;

    public void init() {
        setApplet(this);
        String media = "media";
        String param = null;
        if ((param = getParameter("dir")) != null) {
            media = param;
        }
        demo = new JavaSound(media);
        Container contentPane = getContentPane();
        contentPane.add(demo.getPanel());
    }

    public void start() {
        demo.open();
    }

    public void stop() {
        demo.close();
    }

    public static JavaSoundApplet getApplet() {
        return applet;
    }

    public static void setApplet(JavaSoundApplet applet) {
        JavaSoundApplet.applet = applet;
    }
}
